- [HTTP request](https://docs.cloud.google.com/compute/docs/reference/rest/beta/serviceAttachments/get#body.HTTP_TEMPLATE)
- [Path parameters](https://docs.cloud.google.com/compute/docs/reference/rest/beta/serviceAttachments/get#body.PATH_PARAMETERS)
- [Query parameters](https://docs.cloud.google.com/compute/docs/reference/rest/beta/serviceAttachments/get#body.QUERY_PARAMETERS)
- [Request body](https://docs.cloud.google.com/compute/docs/reference/rest/beta/serviceAttachments/get#body.request_body)
- [Response body](https://docs.cloud.google.com/compute/docs/reference/rest/beta/serviceAttachments/get#body.response_body)
  - [JSON representation](https://docs.cloud.google.com/compute/docs/reference/rest/beta/serviceAttachments/get#body.ServiceAttachment.SCHEMA_REPRESENTATION)
- [Authorization scopes](https://docs.cloud.google.com/compute/docs/reference/rest/beta/serviceAttachments/get#body.aspect)
- [IAM Permissions](https://docs.cloud.google.com/compute/docs/reference/rest/beta/serviceAttachments/get#body.aspect_1)
- [Try it!](https://docs.cloud.google.com/compute/docs/reference/rest/beta/serviceAttachments/get#try-it)

Returns the specified ServiceAttachment resource in the given scope.

### HTTP request

Choose an endpoint:
global africa-south1 asia-east1 asia-east2 asia-northeast1 asia-northeast2 asia-northeast3 asia-south1 asia-south2 asia-southeast1 asia-southeast2 asia-southeast3 australia-southeast1 australia-southeast2 europe-central2 europe-north1 europe-north2 europe-southwest1 europe-west1 europe-west10 europe-west12 europe-west2 europe-west3 europe-west4 europe-west6 europe-west8 europe-west9 me-central1 me-central2 me-west1 northamerica-northeast1 northamerica-northeast2 northamerica-south1 southamerica-east1 southamerica-west1 us-central1 us-east1 us-east4 us-east5 us-south1 us-west1 us-west2 us-west3 us-west4   
`GET https://compute.googleapis.com/compute/beta/projects/{project}/regions/{region}/serviceAttachments/{serviceAttachment}`

<br />

The URLs use [gRPC Transcoding](https://google.aip.dev/127) syntax.

### Path parameters

| Parameters ||
|---|---|
| `project` | `string` Project ID for this request. |
| `region` | `string` Name of the region of this request. |
| `serviceAttachment` | `string` Name of the ServiceAttachment resource to return. |

### Query parameters

| Parameters ||
|---|---|
| `showNatIps` | `boolean` Indicates whether NAT IPs should be included in the response. |

### Request body

The request body must be empty.

### Response body

Represents a ServiceAttachment resource.

A service attachment represents a service that a producer has exposed. It encapsulates the load balancer which fronts the service runs and a list of NAT IP ranges that the producers uses to represent the consumers connecting to the service.

If successful, the response body contains data with the following structure:

| JSON representation |
|---|
| ``` { "kind": string, "id": string, "creationTimestamp": string, "name": string, "description": string, "selfLink": string, "region": string, "producerForwardingRule": string, "targetService": string, "connectionPreference": enum, "connectedEndpoints": [ { "status": enum, "pscConnectionId": string, "endpoint": string, "endpointWithId": string, "consumerNetwork": string, "propagatedConnectionCount": integer, "natIps": [ string ] } ], "natSubnets": [ string ], "enableProxyProtocol": boolean, "consumerRejectLists": [ string ], "consumerAcceptLists": [ { "projectIdOrNum": string, "networkUrl": string, "endpointUrl": string, "connectionLimit": integer } ], "pscServiceAttachmentId": { "high": string, "low": string }, "fingerprint": string, "domainNames": [ string ], "reconcileConnections": boolean, "tunnelingConfig": { "routingMode": enum, "encapsulationProfile": enum }, "propagatedConnectionLimit": integer, "metadata": { string: string, ... }, "natIpsPerEndpoint": integer } ``` |

| Fields ||
|---|---|
| `kind` | `string` Output only. Type of the resource. Always `compute#serviceAttachment` for service attachments. |
| `id` | `string (https://developers.google.com/discovery/v1/type-format format)` Output only. The unique identifier for the resource type. The server generates this identifier. |
| `creationTimestamp` | `string` Output only. Creation timestamp in [RFC3339](https://www.ietf.org/rfc/rfc3339.txt) text format. |
| `name` | `string` Name of the resource. Provided by the client when the resource is created. The name must be 1-63 characters long, and comply with [RFC1035](https://www.ietf.org/rfc/rfc1035.txt). Specifically, the name must be 1-63 characters long and match the regular expression `[a-z]([-a-z0-9]*[a-z0-9])?` which means the first character must be a lowercase letter, and all following characters must be a dash, lowercase letter, or digit, except the last character, which cannot be a dash. |
| `description` | `string` An optional description of this resource. Provide this property when you create the resource. |
| `selfLink` | `string` Output only. Server-defined URL for the resource. |
| `region` | `string` Output only. URL of the region where the service attachment resides. This field applies only to the region resource. You must specify this field as part of the HTTP request URL. It is not settable as a field in the request body. |
| `producerForwardingRule (deprecated)` | `string` > [!WARNING] > This item is deprecated! The URL of a forwarding rule with loadBalancingScheme INTERNAL\* that is serving the endpoint identified by this service attachment. |
| `targetService` | `string` The URL of a service serving the endpoint identified by this service attachment. |
| `connectionPreference` | `enum` The connection preference of service attachment. The value can be set to `ACCEPT_AUTOMATIC`. An `ACCEPT_AUTOMATIC` service attachment is one that always accepts the connection from consumer forwarding rules. |
| `connectedEndpoints[]` | `object` Output only. An array of connections for all the consumers connected to this service attachment. |
| `connectedEndpoints[].status` | `enum` The status of a connected endpoint to this service attachment. |
| `connectedEndpoints[].pscConnectionId` | `string (https://developers.google.com/discovery/v1/type-format format)` The PSC connection id of the connected endpoint. |
| `connectedEndpoints[].endpoint` | `string` The url of a connected endpoint. |
| `connectedEndpoints[].endpointWithId` | `string` The url of a connected endpoint with resource id. |
| `connectedEndpoints[].consumerNetwork` | `string` The url of the consumer network. |
| `connectedEndpoints[].propagatedConnectionCount` | `integer (https://developers.google.com/discovery/v1/type-format format)` The number of consumer Network Connectivity Center spokes that the connected Private Service Connect endpoint has propagated to. |
| `connectedEndpoints[].natIps[]` | `string` NAT IPs of the connected PSC endpoint and those of other endpoints propagated from it. |
| `natSubnets[]` | `string` An array of URLs where each entry is the URL of a subnet provided by the service producer to use for NAT in this service attachment. |
| `enableProxyProtocol` | `boolean` If true, enable the proxy protocol which is for supplying client TCP/IP address data in TCP connections that traverse proxies on their way to destination servers. |
| `consumerRejectLists[]` | `string` Specifies a list of projects or networks that are not allowed to connect to this service attachment. The project can be specified using its project ID or project number and the network can be specified using its URL. A given service attachment can manage connections at either the project or network level. Therefore, both the reject and accept lists for a given service attachment must contain either only projects or only networks. |
| `consumerAcceptLists[]` | `object` Specifies which consumer projects or networks are allowed to connect to the service attachment. Each project or network has a connection limit. A given service attachment can manage connections at either the project or network level. Therefore, both the accept and reject lists for a given service attachment must contain either only projects or only networks or only endpoints. |
| `consumerAcceptLists[].projectIdOrNum` | `string` The project id or number for the project to set the limit for. |
| `consumerAcceptLists[].networkUrl` | `string` The network URL for the network to set the limit for. |
| `consumerAcceptLists[].endpointUrl` | `string` The URL for the PSC endpoint to accept |
| `consumerAcceptLists[].connectionLimit` | `integer (https://developers.google.com/discovery/v1/type-format format)` The value of the limit to set. For endpointUrl, the limit should be no more than 1. |
| `pscServiceAttachmentId` | `object` Output only. An 128-bit global unique ID of the PSC service attachment. |
| `pscServiceAttachmentId.high` | `string (https://developers.google.com/discovery/v1/type-format format)` |
| `pscServiceAttachmentId.low` | `string (https://developers.google.com/discovery/v1/type-format format)` |
| `fingerprint` | `string (https://developers.google.com/discovery/v1/type-format format)` Fingerprint of this resource. A hash of the contents stored in this object. This field is used in optimistic locking. This field will be ignored when inserting a `ServiceAttachment`. An up-to-date fingerprint must be provided in order to patch/update the ServiceAttachment; otherwise, the request will fail with error `412 conditionNotMet`. To see the latest fingerprint, make a `get()` request to retrieve the ServiceAttachment. A base64-encoded string. |
| `domainNames[]` | `string` If specified, the domain name will be used during the integration between the PSC connected endpoints and the Cloud DNS. For example, this is a valid domain name: "p.mycompany.com.". Current max number of domain names supported is 1. |
| `reconcileConnections` | `boolean` This flag determines whether a consumer accept/reject list change can reconcile the statuses of existing ACCEPTED or REJECTED PSC endpoints. - If false, connection policy update will only affect existing PENDING PSC endpoints. Existing ACCEPTED/REJECTED endpoints will remain untouched regardless how the connection policy is modified . - If true, update will affect both PENDING and ACCEPTED/REJECTED PSC endpoints. For example, an ACCEPTED PSC endpoint will be moved to REJECTED if its project is added to the reject list. For newly created service attachment, this boolean defaults to false. <br /> |
| `tunnelingConfig` | `object` When a tunneling config is set on this service attachment it will encapsulate traffic between consumer and producer. When tunneling is enabled: - natSubnets must be unset - enableProxyProtocol must be false - producerForwardingRule must be a L4 ILB. - |
| `tunnelingConfig.routingMode` | `enum` How this Service Attachment will treat traffic sent to the tunnel_ip, destined for the consumer network. |
| `tunnelingConfig.encapsulationProfile` | `enum` Specify the encapsulation protocol and what metadata to include in incoming encapsulated packet headers. |
| `propagatedConnectionLimit` | `integer (https://developers.google.com/discovery/v1/type-format format)` The number of consumer spokes that connected Private Service Connect endpoints can be propagated to through Network Connectivity Center. This limit lets the service producer limit how many propagated Private Service Connect connections can be established to this service attachment from a single consumer. If the connection preference of the service attachment is ACCEPT_MANUAL, the limit applies to each project or network that is listed in the consumer accept list. If the connection preference of the service attachment is ACCEPT_AUTOMATIC, the limit applies to each project that contains a connected endpoint. If unspecified, the default propagated connection limit is 250. |
| `metadata` | `map (key: string, value: string)` Metadata of the service attachment. |
| `natIpsPerEndpoint` | `integer (https://developers.google.com/discovery/v1/type-format format)` The number of NAT IP addresses to be allocated per connected endpoint. If not specified, the default value is 1. |

### Authorization scopes

Requires one of the following OAuth scopes:

- `https://www.googleapis.com/auth/compute.readonly`
- `
  https://www.googleapis.com/auth/compute`
- `
  https://www.googleapis.com/auth/cloud-platform`

For more information, see the [Authentication Overview](https://docs.cloud.google.com/docs/authentication#authorization-gcp).

### IAM Permissions

In addition to any permissions specified on the fields above, authorization requires one or more of the following [IAM](https://cloud.google.com/iam/docs/) permissions:

- `compute.serviceAttachments.get`

To find predefined roles that contain those permissions, see [Compute Engine IAM Roles](https://docs.cloud.google.com/compute/docs/access/iam).